!-----------------------------------------------------------------------------
! Magic and Fight System --- Pronouns
! For INFORM compiler and Z-Machine text based Adventure games
!-----------------------------------------------------------------------------
!  Author: Giancarlo Niccolai
!  Version: 1.3
!  Last Revised: 2002-11-24
!  Contact author at: giancarlo@niccolai.ws
!  Feel free to use and distribute this file, but please report me if
!  you intend to change it (in better), so we can upgrade together
!
!  Released under GPL 2.0, or any later version at your will
!
!-----------------------------------------------------------------------------
! Flexible pronoun declaration to handle spells and attacks that can be aimed
! to things, NPC or players
!------------------------------------------------------------------------------

ifndef pron;

[pron x;
   if (x == player) print "tu";
   else if (x has pluralname) print "essi";
   else if (x has neuter || x hasnt animate)
      print "esso";
   else if (x has female) print "essa";
   else print "egli";
];

[pacc x;
   if (x == player) print "te";
   else if (x has pluralname) print "loro";
   else if (x has neuter || x hasnt animate)
      print "esso";
   else if (x has female) print "lei";
   else print "lui";
];

[onpacc x;
   print "su di ", (pacc) x;
];

[atpacc x;
   if (x has neuter || x hasnt animate) print "ad ";
   else print "a ";
   print (pacc) x;
];


[ppos y x;
   x = parent( y );

   if (x has pluralname )
      print "loro";
   else {
      if (x == player ) print "t";
      else print "s";

      if (y has pluralname) {
         if ( y has female ) print "ue";
         else print "uoi";
      }
      else {
         if (y has female) print "ua";
         else print "uo";
      }
   }
   print " ",(name) y;
];

[artppos x;
   if ( x has pluralname ) {
      if ( x has female ) "le ";
      else print "i ";
   }
   else {
      if ( x has female ) "la ";
      else print "il ";
   }
   print (ppos) x;
];

[indartppos y;
   if ( y has pluralname ) {
      if ( y has female ) print "delle ";
      else print "dei ";
   }
   else {
      if (y has female) print "della ";
      else print "del ";
   }
   print (ppos) y;
];

[atppos y;
   if ( y has pluralname ) {
      if ( y has female ) print "alle ";
      else print "ai ";
   }
   else {
      if (y has female) print "alla ";
      else print "al ";
   }
   print (ppos) y;
];

[onppos y;
   if ( y has pluralname ) {
      if ( y has female ) print "sulle ";
      else print "sui ";
   }
   else {
      if (y has female) print "sulla ";
      else print "sul ";
   }
   print (ppos) y;
];


[tohave x;
   if (x == player) print "hai";
   else if (x has pluralname) print "hanno";
   else print "ha";
];

[ctohave x;
   if (x == player) print "Hai";
   else if (x has pluralname) print "Hanno";
   else print "Ha";
];

!
! Mix di pronome personale o accusativo per il giocatore (tu/te) o
! il nome dell'oggetto (il... )
!

!soggetto
[youthe x;
   if ( x == player ) print "tu";
   else print (the) x;
];

! soccetto maiuscolo
[cyouthe x;
   if ( x == player ) print "Tu";
   else print (The) x;
];

!pronome accusativo
[ytpacc x;
   if ( x == player ) print "te";
   else print (the) x;
];

[onytpacc x;
   if ( x == player ) print "su di te";
   if ( x has proper)
      print "su ", (name) x;
   else print (artsu) x;
];

[atytpacc x;
   if ( x == player ) print "a te";
   if ( x has proper)
      print "a ", (name) x;
   else print (arta) x;
];

!
! Declina una parola maschile o femminile a seconda di un numero dato
!

[numm x;
   if ( x == 1 )
      print "o";
   else
      print "i";
];

[numf x;
   if ( x == 1 )
      print "a";
   else
      print "e";
];


Endif;
! end of MFS_Pronouns.h
