!-----------------------------------------------------------------------------
! Magic And Fight System --- Special Spells
! For INFORM compiler and Z-Machine text based Adventure games
!-----------------------------------------------------------------------------
!  Author: Giancarlo Niccolai
!  Version: 1.3
!  Last Revised: 2002-11-24
!  Contact author at: giancarlo@niccolai.ws
!  Feel free to use and distribute this file, but please report me if
!  you intend to change it (in better), so we can upgrade together
!
!  Released under GPL 2.0, or any later version at your will
!
!-----------------------------------------------------------------------------
! Special verbs management used in spell and magic systems
!-----------------------------------------------------------------------------

Ifndef MFS_SpeciaVerbs;
Constant MFS_SpeciaVerbs;
!--------------------------------------------------------
! Unknown verb for casting management
! recognise a spell in the form "spell_name at..." or
! "power word"
!
Ifdef Spell;
Ifdef MagicGenerator;
[ UnknownVerb word i;
	objectloop (i ofclass Spell && i has known_about)
		if (word==(i.&name)-->0) {
		  	the_spell = i;
			return 'direct cast';
		}
	objectloop (i ofclass MagicGenerator)
        if (i.usable_pword(word)) {
			the_spell = word;
			the_object = i;
			return 'generator cast';
		}

  rfalse;
];
endif;
endif;

Ifdef Spell;
Ifndef UnknownVerb;
[ UnknownVerb word i;
	objectloop (i ofclass Spell && i has known_about)
		if (word==(i.&name)-->0) {
		  	the_spell = i;
			return 'direct cast';
		}

  rfalse;
];
endif;
endif;

Ifdef MagicGenerator;
Ifndef UnknownVerb;
[ UnknownVerb word i;
	objectloop (i ofclass Spell && i has known_about)
		if (word==(i.&name)-->0) {
		  	the_spell = i;
			return 'direct cast';
		}
	objectloop (i ofclass MagicGenerator)
        if (i.usable_pword(word)) {
			the_spell = word;
			the_object = i;
			return 'generator cast';
		}

  rfalse;
];
endif;
endif;
!----------------------------------------------------------------------
! Prints the name of a verb in magic system
!
Ifdef Spell;
[PrintVerb v;
	if (v=='direct cast') { print "lancia un incantesimo"; rtrue; }
	if (v=='generator cast') { print "usa i poteri degli oggetti magici"; rtrue; }
	rfalse;
];
Endif;

Endif;

! End of MFS_SpecialVerbs.h

